#include <list>
#include <string>
#include <tr1/unordered_map>
#include "l7vs_dest.h"
#include "module_sslid_hash.h"
#include "module_sslid_hash_map.h"

static CSSLIDMap idmap;

void hash_setPointer(const void *keymap, const void *keylist, unsigned int size)
{
  idmap.setPointer((IDLIST *)keymap, (IDLIST *)keylist, size);
}


void hash_add(const char *key, struct l7vs_dest data)
{
  idmap.add(key, data);
}


int hash_search(const char *key, struct l7vs_dest **data)
{
  struct l7vs_dest *tmpdata;
  int retcode;
  bool retcode_boolean;

  retcode_boolean = idmap.search(key, &tmpdata);
  
  if (true == retcode_boolean) {
    *data = tmpdata;
    retcode = 0;

  } else {
    retcode = -1;

  }

  return retcode;
}


void hash_allocate(unsigned int size)
{
  idmap.allocate(size);
}


void hash_destroy(void)
{
  idmap.destroy();
}

  
void *hash_getIDMAP(void)
{
  return idmap.getIDMAP();
}


void *hash_getIDLIST(void)
{
  return idmap.getIDLIST();
}


int hash_getLISTSIZE(void)
{
  return idmap.getLISTSIZE();
}
