#include <iostream>
#include <sstream>
#include <list>
#include <string>
#include <tr1/unordered_map>
#include "l7vs_dest.h"
#include "module_sslid_hash_map.h"


CSSLIDMap::CSSLIDMap()
{
  listsize = 0;
}


CSSLIDMap::~CSSLIDMap()
{
  // nothing to do
}


void CSSLIDMap::allocate(unsigned int size)
{
  m = new IDMAP;
  l = new IDLIST;
  listsize = size;
}


void CSSLIDMap::destroy(void)
{
  if (m) {
    delete m;
    m = NULL;
  }

  if (l) {
    delete l;
    l = NULL;
  }
}


void CSSLIDMap::add(const std::string key, struct l7vs_dest data)
{
  if (m->size() >= listsize) {
    m->erase(m->find(*(l->begin())));
    l->pop_front();
  }

  m->insert(IDMAP::value_type(key, data));
  l->push_back(key);
}


bool CSSLIDMap::search(const std::string key, l7vs_dest **data)
{
  bool retval;

  IDMAP::const_iterator it = m->find(key);

  if (it == m->end()) {
    retval = false;
  } else {
    //    *data = it->second;
    *data = (struct l7vs_dest*)&it->second;
    retval = true;
  }

  return retval;
}


void *CSSLIDMap::getIDMAP(void)
{
  return (void *)m;
}


void *CSSLIDMap::getIDLIST(void)
{
  return (void *)l;
}

int CSSLIDMap::getLISTSIZE(void)
{
  return listsize;
}


void CSSLIDMap::setPointer(const void *keymap, const void *keylist, unsigned int size)
{
  m = (IDMAP *)keymap;
  l = (IDLIST *)keylist;
  listsize = size;
}
